"use strict";
Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.languages = void 0;
var _htmlEscaper = require("html-escaper");
var _mixter = require("mixter");
var _syntax = require("./syntax");
const languages = {};
exports.languages = languages;
const compiled = new Map();
const style = /*css*/ `
:host {
  display: block;
}
* {
  color: var(--color);
}
*::selection {
  background: var(--selection) !important;
}
pre {
  margin: 0;
}
slot {
  display: none;
}`;
const keyStyle = (x)=>/*css*/ `
.${x} {
  color: var(--${x});
  font-style: var(--${x}-style);
  font-weight: var(--${x}-weight);
}`
;
let CodeSyntaxElement = class CodeSyntaxElement extends (0, _mixter).mixter(HTMLElement, (0, _mixter).shadow(/*html*/ `<style>${style}</style><slot></slot><pre><code></code></pre>`), (0, _mixter).attrs(class {
    codeHTML = String;
    language = String;
    theme = String;
}), (0, _mixter).props(class {
    syntax;
    code;
    codeRawText;
    highlight;
    onTextContent;
}), (0, _mixter).state(({ $ , effect , reduce  })=>{
    $.code = reduce(({ root  })=>root.querySelector('code')
    );
    // prevents unstyled content from showing until attributes
    // have arrived and the actual syntax has compiled
    setTimeout(()=>{
        if ($.highlight == null) $.highlight = _htmlEscaper.escape;
    }, 100);
    effect(({ language  })=>{
        if (language in languages) $.syntax = languages[language];
    });
    effect(async ({ root , syntax  })=>{
        let { style: style1 , regexp  } = compiled.get(syntax) ?? {};
        if (!regexp || !style1) {
            regexp = await (0, _syntax).compile(syntax);
            style1 = new CSSStyleSheet();
            await style1.replace([
                ...regexp.keys
            ].map(keyStyle).join(''));
            compiled.set(syntax, {
                style: style1,
                regexp
            });
        }
        root.adoptedStyleSheets = [
            style1
        ];
        $.highlight = (s)=>(0, _syntax).syntax(regexp, s)
        ;
    });
    effect(({ root  })=>(0, _mixter).onTextChange(root, (text)=>{
            $.codeRawText = text;
        })
    );
    $.codeHTML = reduce(({ codeRawText , highlight  })=>highlight(codeRawText)
    );
    effect(({ code , codeHTML  })=>{
        code.innerHTML = codeHTML;
    });
})) {
};
exports.CodeSyntaxElement = CodeSyntaxElement;
